'use strict'

// Global features
const env = require("./toolbox").env

// Global features
const Queue = require("./manager").queue
const Browser = require("./manager").browser

// Queue
let tasks = new Queue()

module.exports = {
    setup: env.moduleSetup,
    queueDesktop: (url, setup=null) => {
        tasks.add({
            url: url,
            version: env.desktop,
            picName: "desktop",
            setup: setup
        })
    },
    queueIpad: async (url, setup=null) => {
        tasks.add({
            url: url,
            version: env.ipad,
            picName: "pad",
            setup: setup
        })
    },
    queueIphone: async (url, setup=null) => {
        tasks.add({
            url: url,
            version: env.iphone,
            picName: "iphone",
            setup: setup
        })
    },
    queueAndroid: async (url, setup=null) => {
        tasks.add({
            url: url,
            version: env.android,
            picName: "android",
            setup: setup
        })
    },
    queueAll: async (url, setup=null) => {
        module.exports.queueDesktop(url, setup)
        module.exports.queueIpad(url, setup)
        module.exports.queueIphone(url, setup)
        module.exports.queueAndroid(url, setup)
    },
    execute: async () => {
        let browser = new Browser()
        await browser.execute(tasks)
    }
}